---
title: 写在“锐龙”上市之际——AMD那段励志的故事
date: 2017-02-24T20:27:13+08:00
draft: false
excerpt: 十年磨一剑，AMD Ryzen终于来了。可是AMD背后的故事，又有多少人了解？
tags:
  - AMD
  - Intel
---

北京时间2月22日22:00，AMD在美国正式发布了全新的Ryzen（中文名“锐龙”）处理器。

作为A饭，怎按捺得住内心的激动！要知道在这以前的很长一段时间里，PC半导体行业都被牙膏厂Intel支配，想买到高性能的U，穷鬼也只好捡破烂了。真不敢相信，自己竟能在有生之年见证“农奴翻身把歌唱”之日！实测AMD Ryzen 7 1800X完全可以匹敌Intel Core i7-6900K，而且价格还是后者的一半（黑心牙膏厂一直都在利用垄断攫取暴利）。桌面CPU市场终于可以从Intel挤牙膏的节奏中走出来，风暴终于来临了！

{{< figure src="https://ojirvqiyr.qnssl.com/images/2017/img001.jpg" alt="Ryzen发布" caption="Ryzen来了！" width="1022" height="611" >}}

也许直到今天，我们谈起AMD时，一些人仍会感到陌生，就算知道这家企业，印象也往往是什么CPU性能不如Intel、GPU市场份额没NVIDIA高之类的。必须承认的是AMD曾一度一蹶不振，持续低迷了很长一段时间，曾经的辉煌已鲜有人知。下面我们就来谈谈AMD的发展历程吧，一段艰苦奋斗的励志故事。

首先我有必要解释一下，AMD是"Advanced Micro Devices"的缩写，翻译过来就是“超微半导体公司”，简称“超微”或“超威”（也许是因为在IT业界还有一家知名的主板企业“SuperMicro”在中国同样被称为“超微”，官方确定的中文名是“超威半导体”）。

## 最初的十二年

AMD成立于1969年，只比Intel晚一年，但它的基础却比Intel公司薄弱得多。公司的启动资金只有10万美元，刚成立时只能在创办人之一的约翰·凯利（John Carey）家中的客厅办公。除资金问题外，人才的缺乏也是AMD公司成立之初的一大棘手问题。Intel的两位创业者，诺伊斯（Robert Noyce）是集成电路的发明者之一，戈登·摩尔（Gordon Moore）则是著名的摩尔定律（Moore's Law）的提出者，他们在创办Intel前就在业界享有很高声望。而AMD就是一家普普通通的创业公司，不被大家看好，也很难吸引到人才。因此，AMD的创业初期可谓是困难重重。

{{< figure src="https://ojirvqiyr.qnssl.com/images/2017/jerry-sanders.jpg" alt="AMD创始人桑德斯（Jerry Sanders）" caption="AMD重要的创始人桑德斯（Jerry Sanders）" width="1000" height="594" >}}

通过团队的不懈努力，几个月后，AMD推出了第一个产品——一个4位的寄存器Am9300。次年AMD推出出了自己的专利产品 Am2501逻辑计数器（Am2501 logic counter）, 取得了成功。之后AMD又相继开始生产晶圆，发行股票，在马来西亚建立生产基地，进入RAM市场……一直稳步发展。

## 与Intel的合约

Intel的先天优势使它在微处理器的研制上一开始就处于领先地位。1974年Intel研发出8位微处理器8080。AMD看到了微处理器所蕴藏的巨大市场，投入技术力量进行研究，根据逆向工程第二年就开发出兼容8080的微处理器8080A，投放市场。当时，为Intel设计出全世界第一颗微处理器的工程师Federico Faggin带领安泽曼、西玛等人离开Intel，投靠石油大亨埃克森（Exron），成立了Zilog公司，研制出一种叫Z80的微处理器，性能上甚至高于Intel同档次的8085（8080的增强型）。Intel为和Zilog竞争，需要生产更多的8085，但又苦于自己的生产能力不够。这时创始人桑德斯亲自到Intel公司总部谈判授权事宜，Intel同意授权AMD做它的第二供应商（Second Source）。

之后，AMD表现出强劲的发展势头，公司的业绩达到了一个又一个的里程碑。当Intel开发出16位处理器8086时，却迟迟不愿给AMD授权，因为此时Zilog公司的威胁已不那么严重，Intel认为自己不需要借助AMD的力量了。何况AMD生产的芯片已经对Intel自己的产品构成了威胁，Intel不愿看到AMD再继续发展壮大。

Intel在1978年推出了世界上第一颗x86微型处理器。1981年，IBM设计出了自己的PC产品并希望使用Intel的x86处理器，同时要求将AMD作为第二供应商。Intel不想丢失像IBM这样大的订单，只好又一次与AMD谈判，签署了一个十年技术交换协定（10-year technology exchange agreement）。1984年AMD的销售额达到了创纪录的11亿美元，同年Intel的销售额是16亿美元，作为第二供应商，能取得这样的成绩是很不容易的。此时，Intel已经有点坐不住了，准备采取些行动，防患于未然。

{{< figure src="https://ojirvqiyr.qnssl.com/images/2017/img002.jpg" alt="Intel i386 & AMD Am386" caption="Intel的i386和AMD的Am386" class="right" width="359" height="558" >}}

1985年Intel推出了32位处理器80386，但是当386芯片正式上市后，Intel却宣布将由自己独家制造。AMD公司和桑德斯本人都被Intel的出尔反尔激怒了,根据双方1981年签订的协议获得授权是理所当然的事情。在双方谈判无效的情况下，AMD在1987年一纸诉状将Intel告上了法庭。

对于Intel公司来说，只要诉讼一天没有最终判决，AMD就一天不能生产386芯片，所以就想尽办法把这场官司拖着，希望能拖垮AMD。要是AMD像这样一味等待无异于坐以待毙。桑德斯果断地决定，AMD要自主开发完全兼容80386的芯片。

一个精干的技术团队迅速投入开发工作，终于在1989年开发出AMD自己的386芯片Am386。但就在AMD公司上下举杯庆贺、为Am386的正式上市作准备的时候，Intel从一个极其偶然的机会获得了这一信息。为阻止AMD借助此新产品东山再起，Intel别出心裁地想出个理由，起诉AMD非法使用“386”这一所谓Intel的名字，Am386的上市又被拖延了。好在法院最后判定386是一个通用的名字，而非Intel所专用，Am386才得以上市，但这已经是1991年3月的事情了。虽然在Intel的百般刁难下，AMD错过了销售新产品的最佳时机，但Am386的推出对于AMD来说意义重大，它打破了Intel一手垄断PC处理器市场的局面，是AMD独立研发处理器的成功开始。

AMD和Intel的官司从1987年开始，一直拖到1995年才最终结束。最后AMD终于取得了生产X86处理器的权利，赢得了在PC芯片业中的生存权和发展权，同时也为此付出了惨重的代价：数千万美元的诉讼开支、公司高层精力的分散以及新产品不能上市的无奈等，难以尽述。AMD能在旷日持久的“马拉松”式的诉讼中坚持下来，与桑德斯顽强不屈、百折不挠的个性是分不开的。这位AMD的领头羊和精神领袖出生在芝加哥一个底层家庭，有一种硬汉子的脾性。在和Intel的抗争过程中，桑德斯毫不屈服，正如他所说的那样：“永不放弃，永不投降！”，因此被誉为“硅谷牛仔”。

## 开发自己的微处理器

接下来AMD在1993年发布Am486，以比Intel版本更低的价格销售。很多OEM，包括Compaq都使用Am486。其实到目前为止，AMD设计的每一款处理器都是逆向工程Intel的产品得到的。由于电脑工业生产周期的缩短，这种策略令AMD越来越难生存下去，因为这意味着他们的技术将一直落在Intel的后头。于是，AMD坚定地走上了一条自主开发处理器的发展之路。

> 我们不能只做Intel的追随者，我们此前似乎一直在模仿或追赶它，这种做法大错特错。
  <cite>桑德斯（Jerry Sanders）</cite>

1993年，AMD宣布了独立开发AMD K5处理器的项目，业界纷纷看好这颗K5的架构与性能。但是由于采用了全新架构，研制工作的复杂度和难度都大大增加，到了1994年AMD预定发布的日子，K5的开发工作还未完成，因而挫伤了外界对它的热情。1995年K5处理器终于上市，AMD对这款处理器给予了很高的期望，希望它能狙击Intel势头正盛奔腾（Pentium）处理器。可这时AMD才发现自己的一个重大失误：K5和Pentium的针脚不兼容。当时绝大多数主板都是为Pentium处理器设计的，要采用AMD的K5处理器就必须重新设计新的芯片组和主板，而依AMD当时的实力和影响力又无法做到这一点，结果K5的架构一直无法推广起来。这给了AMD一个沉痛的教训：即使有比市场主流产品更优越的架构，如果不能兼容于市场上的现有规格，还是无法成功的！

经历K5的惨痛教训后，AMD决定引进新的技术力量以充实开发队伍。1996年收购了NexGen。随后推出K6、K7。其中具有K7具有重大战略意义，被命名为Athlon（速龙）。Athlon在性能测试中全面超过当时的Pentium Ⅲ处理器，从Am386到K7，经过长期不懈的努力，AMD终于在CPU技术上超越了Intel。

2002年4月24日，AMD正式推出了K8架构的Opteron(皓龙)，它具有划时代意义：世界上第一颗64位的CPU。是的，“amd64”就是这么来的！

与此同时，Intel那边也丝毫不敢松懈，Pentium也一直在不断更新换代。

这段历史也是整个行业发展史上最精彩的篇章。正是由于AMD的存在，Intel才不敢停下脚步，努力创新，生怕自己落后。红蓝大厂之间的竞争，直接加速了技术的进步。

麦克尔·马龙说，在所有的高科技公司中，AMD公司是最可怕，也是最英勇的；它年复一年，代复一代，顽强地挑战这个星球上最成功、最著名、最具竞争力的公司之一。在同Intel的竞争中，Zilog、国家半导体、摩托罗拉、德州仪器、Cyrix、IDT、Rise等一个个败下阵来，不是烟消云散，就是无奈放弃，只有桑德斯带领的AMD，历经33年，不仅没有倒下，而且实力越来越强大。在80年代Intel授权的15家第二供应商中，SIEMENS、FUJITSU、HARRIS等都已放弃，只有AMD一家迄今还屹立在电脑芯片业。无怪乎桑德斯在接受UPSIDE杂采访时无比自豪地说：“唯一能阻止Intel在计算机世界实现全面控制的就是AMD。”

## “后桑德斯”时代

2000年，桑德斯正式把CEO的职务交给公司总裁瑞兹，自己则留任公司的董事长直到明年年底。瑞兹是桑德斯在2000年从摩托罗拉半导体公司挖来的芯片高手，以严格的营运专家著称。桑德斯相信这位新的CEO会做得比自己还好。

现在桑德斯退居幕后了，他留给继任者的是一个在台式机处理器上和Intel分庭抗礼的AMD，一个在工作站和服务器处理器上雄心勃勃的AMD，一个在移动处理器上大举进入的AMD；更重要的是，他留给继任者的是一个在技术创新上已经能与Intel一争高下的AMD。

可是之后发生的事多少有点让人揪心——AMD在与Intel的竞争中落后了。Intel推出了Core(酷睿)处理器，AMD全面落败，从此就一直被Intel压着。Intel也由于竞争对手不给力，开始了挤牙膏……

2006年，AMD收购了ATI，从此有了自己的图形技术。同时，也与NVIDIA成了竞争对手。虽然AMD整体上持续低迷，但是还是取得了一些成就的。2010年，AMD（ATI）独立显示核心出货量超越NVIDIA成为世界第一。2011年，AMD推出APU=CPU+GPU的概念，即融合（Fusion）CPU及GPU于一体。Xbox One及PS4采用的均是AMD的芯片。

不管怎么说，在Intel与NVIDIA的强力围功下，AMD终究还是活了下来。所以业界也有种说法：AMD是打不死的小强。

现在大家该知道为什么Ryzen的发布让广大A饭如此了激动了吧？经历十年的低迷，AMD在处理器性能方面终于又能与Intel抗衡了。也许Ryzen不会使AMD今年的出货量一举超越Intel，但是市场早就需要这么一个搅局者了。Intel如果短时间内不能拿出产品，必然会选择降价，得实惠的还是广大用户。也许Ryzen并不会让AMD在短时间内崛起，但是它向外界释放了一个信号：红色巨人终于从沉睡中醒来！Intel，你还敢挤牙膏么？

英特尔：不知怎么的7nm工艺突然就成熟了，我们决定8代酷睿直接上7nm！

## 鸣谢-Acknowledgements

本文参考并引用了大量资料以及一些大神的帖子，现将主要的贴出：

* 百度贴吧：[【给不了解AMD的你】AMD公司的历史](http://tieba.baidu.com/p/762849907)；
* Wikipedia维基百科：[Advanced Micro Devices](https://en.wikipedia.org/wiki/Advanced_Micro_Devices)。
